/* Header file for Digital Research and Microsoft object module formats */
/*                                                                      */
/* Copyright (c) 1991, Stuart G. Phillips.  All rights reserved.        */
/*                                                                      */
/* Permission is granted for non-commercial use of this software.       */
/* You are expressly prohibited from selling this software in any form, */
/* distributing it with another product, or removing this notice.       */
/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR       */
/* IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED       */
/* WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR           */
/* PURPOSE.                                                             */
/*                                                                      */
/* NOTE: These structure declarations will only work correctly when     */
/*       used with a compiler that does NOT impose word alignment on    */
/*       byte storage classes.                                          */
/*                                                                      */

#define CHDRSIZE        128
#define EXE_MAGIC       0x5a4d          /* Magic number for .EXE files */
#define LOD_MAGIC       0x4655          /* Magic number for .LOD files */
#define LOD_VERSION     0x0101          /* Version of .LOD header format */

struct RELITEM {unsigned short  offset;
                unsigned short  segment;
               };


struct EXEHDR { unsigned short  magic;
                unsigned short  nbytes;
                unsigned short  npages;
                unsigned short  nreloc;
                unsigned short  hdrsize;
                unsigned short  endmin;
                unsigned short  hilo_flag;
                unsigned short  ss_offset;
                unsigned short  val_sp;
                unsigned short  chk_sum;
                unsigned short  val_ip;
                unsigned short  cs_offset;
                unsigned short  rel_offset;
                unsigned short  ovl_num;
              };


struct LODHDR { unsigned short  magic;
                unsigned short  version;
                unsigned short  val_offset;
                unsigned short  val_seg;
                long            time_stamp;
                long            image_size;
              };

struct GRPDESC {char            g_form;
                unsigned short  g_length;
                unsigned short  a_base;
                unsigned short  g_min;
                unsigned short  g_max;
             };

struct CMDHDR { struct GRPDESC desc[1];
              };
